

(defrule paymentRule
(goodsMsgProp  (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) =>	 (bind ?pay-var (new pay ?itemID-var1 ?itemPrice-var1 ?t1))
	(definstance payMsgProp ?pay-var static)
	(store OUTPUT ?pay-var))

(defrule offerRule
(rfqMsgProp  (itemID ?itemID-var1)(transID ?t1)) =>	 (bind ?offer-var (new offer ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance offerMsgProp ?offer-var static)
	(store OUTPUT ?offer-var)(bind ?cc-var(new ConditionalCommitment "merchant"   "customer"   "payProp" "goodsProp" ?t1))
	 (definstance ccom ?cc-var static))

(defrule RFQRule
(startProp) =>	 (bind ?RFQ-var (new RFQ ?itemID-var1 ?t1))
	(definstance RFQMsgProp ?RFQ-var static)
	(store OUTPUT ?RFQ-var))

(defrule acceptRule
(offerMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) =>	 (bind ?accept-var (new accept ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance acceptMsgProp ?accept-var static)
	(store OUTPUT ?accept-var)(bind ?cc-var(new ConditionalCommitment "customer"   "merchant"   "goodsProp" "payProp" ?t1))
	 (definstance ccom ?cc-var static))

(defrule goodsRule
(acceptMsgProp  (itemPrice ?itemPrice-var1) (itemID ?itemID-var1)(transID ?t1)) =>	 (bind ?goods-var (new goods ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance goodsMsgProp ?goods-var static)
	(store OUTPUT ?goods-var))