package edu.ncsu.csc.mas.codeGen;

import edu.ncsu.csc.mas.ontology.Protocol;
import edu.ncsu.csc.mas.ontology.Message;
import edu.ncsu.csc.mas.ontology.Slot;
import java.util.*;

 public class ProtMsgCodeGen
 {
  protected final String NL = System.getProperties().getProperty("line.separator");
  protected final String TEXT_1 = " ";
  protected final String TEXT_2 = NL + "    " + NL + " // ***Attention !!! " + NL + " package edu.ncsu.csc.mas.protocols.";
  protected final String TEXT_3 = ".messagesTemp;" + NL + "" + NL + "import java.io.IOException;" + NL + "import java.io.ObjectInputStream;" + NL + "import java.io.ObjectOutputStream;" + NL + "import java.io.Serializable;" + NL + "" + NL + "import edu.ncsu.csc.mas.enactments.JessJ2EE.JJMessage;" + NL + "" + NL + "public class ";
  protected final String TEXT_4 = " extends JJMessage implements Serializable{" + NL + "\t";
  protected final String TEXT_5 = NL + "    \tprotected ";
  protected final String TEXT_6 = " ";
  protected final String TEXT_7 = " ;";
  protected final String TEXT_8 = "\t" + NL + "" + NL + "    " + NL + " " + NL + "\tpublic ";
  protected final String TEXT_9 = "(";
  protected final String TEXT_10 = "\t";
  protected final String TEXT_11 = " ";
  protected final String TEXT_12 = " ,";
  protected final String TEXT_13 = "\t int transID)" + NL + "\t{" + NL + "\t\tsuper(transID,\"";
  protected final String TEXT_14 = "\");" + NL + "\t\t";
  protected final String TEXT_15 = NL + "    \tthis.";
  protected final String TEXT_16 = "=";
  protected final String TEXT_17 = ";" + NL + "\t\t";
  protected final String TEXT_18 = "\t" + NL + "\t}" + NL + "\t" + NL + "\t";
  protected final String TEXT_19 = NL + "\t" + NL + "\tpublic ";
  protected final String TEXT_20 = " get";
  protected final String TEXT_21 = "() {" + NL + "\t\treturn ";
  protected final String TEXT_22 = ";" + NL + "\t}" + NL + "" + NL + "\tpublic void set";
  protected final String TEXT_23 = "(";
  protected final String TEXT_24 = " ";
  protected final String TEXT_25 = ") {" + NL + "    \tthis.";
  protected final String TEXT_26 = "=";
  protected final String TEXT_27 = ";" + NL + "\t}" + NL + "\t " + NL + "\t";
  protected final String TEXT_28 = "\t" + NL + "\t\t" + NL + "\t\t" + NL + "\t" + NL + "\tpublic void writeObject(ObjectOutputStream s) throws IOException {" + NL + "\t\ts.defaultWriteObject();" + NL + "\t\t// customized serialization code" + NL + "\t\ts.writeObject(getType());" + NL + "\t\ts.writeInt(getTransID());" + NL + "\t}\t" + NL + "\t" + NL + "    public void readObject(ObjectInputStream s) throws IOException, ClassNotFoundException {" + NL + "\t\ts.defaultReadObject();" + NL + "\t\t// customized deserialization code" + NL + "\t\tsetType((String)s.readObject());" + NL + "\t\tsetTransID(s.readInt());" + NL + "\t\t// followed by code to update the object, if necessary" + NL + "\t}" + NL + "}";
  protected final String TEXT_29 = NL + " ";

   public String generate(Object argument1, Object argument2)
  {
    StringBuffer stringBuffer = new StringBuffer();
    stringBuffer.append(TEXT_1);
     Message message = (Message) argument1;
 	Protocol prot = (Protocol) argument2;
 	Vector classParameters = message.getParameters();
    String className = message.getType();
    String packageName= prot.getInstName();
    int numParms = classParameters.size();
    ArrayList varTypes = new ArrayList();
    ArrayList varNames = new ArrayList();		
    for(int i=0;i<numParms;i++)
    {
    	String parameter = ((Slot)classParameters.elementAt(i)).toString();
    	int indexOfDelimiter = parameter.indexOf(":");
    	String varType = parameter.substring(0,indexOfDelimiter);
    	String varName = parameter.substring(indexOfDelimiter+1,parameter.length());
    	varTypes.add(i,varType);
    	varNames.add(i,varName);
    } 	
    
    stringBuffer.append(TEXT_2);
    stringBuffer.append(packageName);
    stringBuffer.append(TEXT_3);
    stringBuffer.append(className);
    stringBuffer.append(TEXT_4);
      for(int i=0;i<classParameters.size();i++) { 
    stringBuffer.append(TEXT_5);
    stringBuffer.append(varTypes.get(i));
    stringBuffer.append(TEXT_6);
    stringBuffer.append(varNames.get(i) );
    stringBuffer.append(TEXT_7);
     } 
    stringBuffer.append(TEXT_8);
    stringBuffer.append(className);
    stringBuffer.append(TEXT_9);
     for(int i=0;i<classParameters.size();i++) { 
    stringBuffer.append(TEXT_10);
    stringBuffer.append(varTypes.get(i));
    stringBuffer.append(TEXT_11);
    stringBuffer.append(varNames.get(i) );
    stringBuffer.append(TEXT_12);
     } 
    stringBuffer.append(TEXT_13);
    stringBuffer.append(className);
    stringBuffer.append(TEXT_14);
      for(int i=0;i<classParameters.size();i++) { 
    stringBuffer.append(TEXT_15);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_16);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_17);
     } 
    stringBuffer.append(TEXT_18);
      for(int i=0;i<classParameters.size();i++) { 
    stringBuffer.append(TEXT_19);
    stringBuffer.append(varTypes.get(i));
    stringBuffer.append(TEXT_20);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_21);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_22);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_23);
    stringBuffer.append(varTypes.get(i));
    stringBuffer.append(TEXT_24);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_25);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_26);
    stringBuffer.append(varNames.get(i));
    stringBuffer.append(TEXT_27);
     } 
    stringBuffer.append(TEXT_28);
    stringBuffer.append(TEXT_29);
    return stringBuffer.toString();
  }
}