/*
 * Created on Oct 21, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;
import com.hp.hpl.jena.ontology.* ;
import com.hp.hpl.jena.rdf.model.*;


/**
 * @author aumallya
 *
 */
public class BooleanSlot extends Slot {
    public Boolean type ;
    
    public BooleanSlot() {
        this.type = new Boolean(true) ;
    }

    public BooleanSlot(OntResource ontBooleanSlot){
        this.name = ontBooleanSlot.getLocalName() ;
        //TODO use the value of the ontBooleanSlot
        this.type = new Boolean(true) ;
    }
    
    public String toString() {
        if(this.name==null || this.type==null)
            return " " ;
        return new String("bool:" + this.name) ;
       
    }
    public String toJessString() {
        if(this.name==null || this.type==null)
            return " " ;
         return new String(this.name) ;
    }
}
