package edu.ncsu.csc.mas.ontology;

import java.util.*;

public class MessageInQueue  {
	
	private String name;
	private Vector slots;
	
	public MessageInQueue()
	{
		this.name=new String();
		this.slots = new Vector();
	}
	
	public MessageInQueue(Message msg) {
		
		
	       this.name = msg.getType()+"Msg";
	       this.slots = msg.getParameters();
	       
	            	
	                     	
	            }
	public Vector getSlots()
	{
		return this.slots;
	}
		
	public String getName()
	{
		return this.name;
	}
		
		
		
	
	public String toJessRuleString(int num)
	{
		String retString="";
		
		retString+="("+ this.name;
		
		if(this.slots!= null) {
            for(int i=0; i<this.slots.size(); i++) {
               	String slot = ((Slot)this.slots.elementAt(i)).toJessString();
                retString +=  (" ("+ slot + " ?" + slot + "-var" +num +")" ) ;
            }
            retString+="(transID ?t" +num + ")";
        }

        retString += ") ";
        
		
		return retString;
		
		
		
	}
	
	public String toString()
	{
String retString="";
		
		retString+="("+ this.name;
		
		if(this.slots!= null) {
            for(int i=0; i<this.slots.size(); i++) {
               	String slot = ((Slot)this.slots.elementAt(i)).toJessString();
                retString +=  (" ("+ slot + " ?" + slot + "-var)"  ) ;
            }
            retString+="(transID ?t)";
        }

        retString += ") ";
        
		
		return retString;
		
	}
	
	

}
