/*
 * Created on Oct 21, 2004
 *
 */
package edu.ncsu.csc.mas.ontology;

import com.hp.hpl.jena.ontology.* ;
import com.hp.hpl.jena.rdf.model.*;


/**
 * @author aumallya
 *
 */
public class StringSlot extends Slot {
    public String type ;
    
    public StringSlot(){
        this.type = new String("") ;
    }
    
    public StringSlot(OntResource ontStringSlot) {
        this.name = ontStringSlot.getLocalName();
        //TODO read the value of the string from the OWL file and use it
        this.type = new String("") ;
    }

    public String toString(){
        if(this.name==null || this.type==null)
            return " " ;
        return new String("string:" + this.name) ;
        
    }
    public String toJessString() {
        if(this.name==null || this.type==null)
            return " " ;
         return new String(this.name) ;
    }
    
}
