package edu.ncsu.csc.mas.protocols.Order.Customer;

import edu.ncsu.csc.mas.utils.JessWrapper;

public class customerOrderPolicy {
	
	protected JessWrapper m_wrapper;
	
	
	public customerOrderPolicy()
	{
		m_wrapper =JessWrapper.getJessWrapperInstance();	
	}
	
	/* Active policy for deciding what item to order */
	public void reqForQuoteMethod()
	{
		m_wrapper.executeCommand("(assert (reqForQuote_Policy (itemID 367)))");
		//m_wrapper.executeCommand("(run)");
	}
	
	/* Passive policy for deciding whether to receive the quote from merchant */ 
	public void quoteMethod(int itemID, double itemPrice)
	{
		m_wrapper.executeCommand("(assert (quote_Policy))");
		//m_wrapper.executeCommand("(run)");
	}
	
	/* Active policy for deciding whether to accept the quote of the merchant */
	public void acceptQuoteMethod(double itemPrice, int itemID)
	{
		m_wrapper.executeCommand("(assert (acceptQuote_Policy))");
		//m_wrapper.executeCommand("(run)");
	}
	
	/* Active policy for deciding whether to reject the quote of the merchant */
	public void rejectQuoteMethod(double itemPrice, int itemID)
	{
		
	}
	
}
