package edu.ncsu.csc.mas.protocols.OrderWithReminders.merchant;

import edu.ncsu.csc.mas.utils.JessWrapper;

public class merchantOrderWithRemindersPolicy {
	
	protected JessWrapper m_wrapper;
	
	
	public merchantOrderWithRemindersPolicy()
	{
		m_wrapper =JessWrapper.getJessWrapperInstance();	
	}
	
	/* Passive policy for deciding whether to handle any requests for quotes for items */
	public void reqForQuoteMethod(int itemID)
	{
		m_wrapper.executeCommand("(assert (reqForQuote_Policy))");
	}
	
	
	/* Active policy for deciding how much to quote for an item */ 
	public void quoteMethod(int itemID)
	{
		m_wrapper.executeCommand("(assert (quote_Policy (itemPrice 47.99)))");
	}
	
	/* Passive policy for deciding whether to receive an acceptQuote message from a customer */
	public void acceptQuoteMethod(double itemPrice, int itemID)
	{
		m_wrapper.executeCommand("(assert (acceptQuote_Policy))");
	}
	
	/* Active policy for decising whether to send a reminder */
	public void reminderMethod(int itemID, double itemPrice)
	{
		m_wrapper.executeCommand("(assert (reminder_Policy))");		
	}
	
	/* Passive policy for deciding whether to receive a rejectQuote message from a customer */
	public void rejectQuoteMethod(double itemPrice, int itemID)
	{
		
	}
}
