(import edu.ncsu.csc.mas.protocols.OrderWithReminders.messages.*)
(import edu.ncsu.csc.mas.enactments.JessJ2EE.*)

(defrule rejectQuote_Policy 
(and (quoteMsgProp (itemID ?itemID-var1) (itemPrice ?itemPrice-var1) (transID ?t1)) (rejectQuoteMsg (itemPrice ?itemPrice-var2) (itemID ?itemID-var2)(transID ?t2)))
 =>	 (call (new merchantOrderWithRemindersPolicy) rejectQuoteMethod  ?itemPrice-var2 ?itemID-var2))

(defrule reqForQuote_Policy 
(and (startPropMsg (transID ?t1)) (reqForQuoteMsg (itemID ?itemID-var2)(transID ?t2)))
 =>	 (call (new merchantOrderWithRemindersPolicy) reqForQuoteMethod  ?itemID-var2))

(defrule reminder_Policy 
(and (remindAbout (itemID ?itemID-var2) (itemPrice ?itemPrice-var2)) (not (positiveDecision)) (not (negativeDecision)))
 =>	 (call (new merchantOrderWithRemindersPolicy) reminderMethod ?itemID-var2 ?itemPrice-var2))

(defrule acceptQuote_Policy 
(and (quoteMsgProp (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) (acceptQuoteMsg (itemPrice ?itemPrice-var2) (itemID ?itemID-var2)(transID ?t2)))
 =>	 (call (new merchantOrderWithRemindersPolicy) acceptQuoteMethod  ?itemPrice-var2 ?itemID-var2))

(defrule quote_Policy 
(reqForQuoteMsgProp  (itemID ?itemID-var1)(transID ?t1))
 =>	 (call (new merchantOrderWithRemindersPolicy) quoteMethod  ?itemID-var1))
