

(defrule quoteRule
(reqForQuoteMsgProp  (itemID ?itemID-var1)(transID ?t1)) =>	 
	(bind ?quote-var (new quote ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance quoteMsgProp ?quote-var static)
	(store OUTPUT ?quote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/Order/customerQ"))
	(bind ?cc-var(new JJConditionalCommitment "merchant"   "customer"   "pay" "goods" ?t1))
	 (definstance ccom ?cc-var static))

(defrule rejectQuoteRule
(quoteMsgProp  (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) =>	 
	(bind ?rejectQuote-var (new rejectQuote ?itemID-var1 ?itemPrice-var1 ?t1))
	(definstance rejectQuoteMsgProp ?rejectQuote-var static)
	(store OUTPUT ?rejectQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/Order/merchantQ")))

(defrule acceptQuoteRule
(quoteMsgProp  (itemID ?itemID-var1) (itemPrice ?itemPrice-var1)(transID ?t1)) =>	 
	(bind ?acceptQuote-var (new acceptQuote ?itemPrice-var1 ?itemID-var1 ?t1))
	(definstance acceptQuoteMsgProp ?acceptQuote-var static)
	(store OUTPUT ?acceptQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/Order/merchantQ"))
	(bind ?cc-var(new JJConditionalCommitment "customer"   "merchant"   "goods" "pay" ?t1))
	 (definstance ccom ?cc-var static))

(defrule reqForQuoteRule
(startProp) =>	 
	(bind ?reqForQuote-var (new reqForQuote ?itemID-var1 ?t1))
	(definstance reqForQuoteMsgProp ?reqForQuote-var static)
	(store OUTPUT ?reqForQuote-var)
	(call JMSWrapper sendTo (new java.lang.String "jms/Order/merchantQ")))