package edu.ncsu.csc.mas.codeGen;

import edu.ncsu.csc.mas.ontology.*;
import java.util.*;

 public class RoleMainCodeGen
 {
  protected final String NL = System.getProperties().getProperty("line.separator");
  protected final String TEXT_1 = " ";
  protected final String TEXT_2 = NL + "    " + NL + " // ***Attention !!! " + NL + "package edu.ncsu.csc.mas.protocols.";
  protected final String TEXT_3 = ".";
  protected final String TEXT_4 = "Temp;" + NL + "" + NL + "import java.io.IOException;" + NL + "import java.util.logging.FileHandler;" + NL + "import java.util.logging.Handler;" + NL + "import java.util.logging.Logger;" + NL + "" + NL + "import edu.ncsu.csc.mas.utils.JMSWrapper;" + NL + "import edu.ncsu.csc.mas.utils.JessWrapper;" + NL + "" + NL + "import edu.ncsu.csc.mas.enactments.JessJ2EE.JJMessage;" + NL + "import edu.ncsu.csc.mas.protocols.";
  protected final String TEXT_5 = ".messages.*;" + NL + "" + NL + "" + NL + "public class Main {" + NL + "\t" + NL + "\tprivate static JessWrapper jsw;\t" + NL + "\tprivate static Logger logger = null;" + NL + "\t" + NL + "\t";
  protected final String TEXT_6 = NL + "\t" + NL + "\tprivate static  final String ";
  protected final String TEXT_7 = "Q = \"jms/default";
  protected final String TEXT_8 = "Q\";";
  protected final String TEXT_9 = NL + "\tprivate static  final String QCFACTORY = \"jms/defaultQcf\";" + NL + "\tprivate static  final String INPUT = \"INPUT\";" + NL + "\tprivate static  final String OUTPUT = \"OUTPUT\";" + NL + "\t" + NL + "\t" + NL + "\tpublic static void main(String[] args) {" + NL + "\t" + NL + "\t\ttry{" + NL + "\t\t\tinitLogger(\"/opt/log/owlp/%t/";
  protected final String TEXT_10 = ".log\");" + NL + "\t\t\t" + NL + "\t\t\tlogger.info(\"Logger initialized\");" + NL + "\t\t\tlogger.info(\"Current working directory for ";
  protected final String TEXT_11 = ":\"+System.getProperty(\"user.dir\"));" + NL + "\t\t\t" + NL + "\t\t\tjsw = JessWrapper.getJessWrapperInstance();" + NL + "\t\t\tlogger.info(\"JessWrapper initialized\");" + NL + "\t\t\t" + NL + "\t\t\tString[] queues = new String[]{";
  protected final String TEXT_12 = " ";
  protected final String TEXT_13 = "Q,";
  protected final String TEXT_14 = "};" + NL + "\t\t\tJMSWrapper.initJMSWrapper(QCFACTORY, queues);" + NL + "\t\t\tlogger.info(\"JMSWrapper initialized\");" + NL + "\t\t\t" + NL + "\t\t\t//Initialize Jess" + NL + "\t\t\tjsw.executeCommand(\"(batch commitments.clp)\");" + NL + "\t\t\tjsw.executeCommand(\"(batch ";
  protected final String TEXT_15 = ".clp)\");" + NL + "\t\t\tjsw.executeCommand(\"(batch ";
  protected final String TEXT_16 = "Policies.clp)\");" + NL + "\t\t\tlogger.info(\"Jess rule system initialized\");" + NL + "\t\t\t" + NL + "\t\t\t// Kick-off the protocol" + NL + "\t\t\tstart st = new start(6481);" + NL + "\t\t\tJMSWrapper.sendTo(";
  protected final String TEXT_17 = "Q,st);" + NL + "\t\t\tlogger.info(\"";
  protected final String TEXT_18 = " agent kicked-off\");" + NL + "\t\t\t" + NL + "\t\t\twhile(true)" + NL + "\t\t\t{" + NL + "\t\t\t\tJJMessage msg = JMSWrapper.blockingReceiveFrom(";
  protected final String TEXT_19 = "Q);" + NL + "\t\t\t\tlogger.info(\"";
  protected final String TEXT_20 = " received:\"+msg.getType());" + NL + "\t\t\t\tString type = msg.getType();" + NL + "\t\t\t\tjsw.store(INPUT, msg);" + NL + "\t\t\t\tjsw.executeCommand(\"(definstance \" +type+ \"Msg (fetch INPUT) static)\");" + NL + "\t\t\t\tlogger.info(\"";
  protected final String TEXT_21 = " stored:\"+msg.getType()+ \"Msg to KB\");" + NL + "\t\t\t\tjsw.executeCommand(\"(run)\");\t\t\t\t" + NL + "\t\t\t\t" + NL + "\t\t\t\tJJMessage send = (JJMessage)jsw.fetch(OUTPUT);" + NL + "\t\t\t\tif(send!=null)" + NL + "\t\t\t\t{\t" + NL + "\t\t\t\t\tJMSWrapper.sendTo(send.getReceiverName().toUpperCase()+\"Q\",send);" + NL + "\t\t\t\t\tlogger.info(\"";
  protected final String TEXT_22 = " sending:\"+send.getType()+ \" to \" + send.getReceiverName());" + NL + "\t\t\t\t} " + NL + "\t\t\t}" + NL + "\t\t\t" + NL + "\t\t}catch(Exception e){" + NL + "\t\t\te.printStackTrace();" + NL + "\t\t\tlogger.info(e.getMessage());" + NL + "\t\t}" + NL + "\t\t" + NL + "\t}" + NL + "" + NL + "\tprivate static void initLogger(String filePath) throws IOException" + NL + "\t{" + NL + "\t\tHandler fh = new FileHandler(filePath);" + NL + "\t\tlogger = Logger.getLogger(\"\");" + NL + "\t\tlogger.addHandler(fh);\t\t" + NL + "\t}" + NL + "\t" + NL + "" + NL + "\tpublic Main() {" + NL + "\t\tsuper();" + NL + "\t}" + NL + "" + NL + "}";

   public String generate(Object argument1, Object argument2)
  {
    StringBuffer stringBuffer = new StringBuffer();
    stringBuffer.append(TEXT_1);
     Role role = (Role) argument1;
 	Protocol prot = (Protocol) argument2;
 	String packageName= prot.getInstName();
 	Vector roles = prot.getRoles();
 
    stringBuffer.append(TEXT_2);
    stringBuffer.append(packageName);
    stringBuffer.append(TEXT_3);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_4);
    stringBuffer.append(packageName);
    stringBuffer.append(TEXT_5);
    for(int i=0;i<roles.size();i++)
	{
    stringBuffer.append(TEXT_6);
    stringBuffer.append(((Role)roles.elementAt(i)).getName().toUpperCase());
    stringBuffer.append(TEXT_7);
    stringBuffer.append(((Role)roles.elementAt(i)).getName());
    stringBuffer.append(TEXT_8);
    }
    stringBuffer.append(TEXT_9);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_10);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_11);
    for(int i=0;i<roles.size();i++)
	{
    stringBuffer.append(TEXT_12);
    stringBuffer.append(((Role)roles.elementAt(i)).getName().toUpperCase());
    stringBuffer.append(TEXT_13);
    }
    stringBuffer.append(TEXT_14);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_15);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_16);
    stringBuffer.append(role.getName().toUpperCase());
    stringBuffer.append(TEXT_17);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_18);
    stringBuffer.append(role.getName().toUpperCase());
    stringBuffer.append(TEXT_19);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_20);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_21);
    stringBuffer.append(role.getName());
    stringBuffer.append(TEXT_22);
    return stringBuffer.toString();
  }
}