package edu.ncsu.csc.mas.protocols.OrderWithReminders.messages;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import edu.ncsu.csc.mas.enactments.JessJ2EE.JJMessage;

public class quote extends JJMessage implements Serializable{
	
	protected int itemID;
	
	protected double itemPrice;

	public quote(int itemID, double itemPrice, int transID)
	{
		super(transID,"quote");
		this.itemID=itemID;
		this.itemPrice = itemPrice;
	}
	
	public int getItemID() {
		return itemID;
	}

	public void setItemID(int itemID) {
		this.itemID = itemID;
	}

	public double getItemPrice() {
		return itemPrice;
	}

	public void setItemPrice(double itemPrice) {
		this.itemPrice = itemPrice;
	}

	public void writeObject(ObjectOutputStream s) throws IOException {
		s.defaultWriteObject();
		// customized serialization code
		s.writeObject(getType());
		s.writeInt(getTransID());
	}	
	
    public void readObject(ObjectInputStream s) throws IOException, ClassNotFoundException {
		s.defaultReadObject();
		// customized deserialization code
		setType((String)s.readObject());
		setTransID(s.readInt());
		// followed by code to update the object, if necessary
	}
}
